;***************************************************************************
; DEFINE SECTION
;***************************************************************************
		INCLUDE "VECTREX.I"
              	INCLUDE "TESTDRAW.I"

                     
                
; start of vectrex memory with cartridge name...

;***************************************************************************
; HEADER SECTION
;***************************************************************************
                DB      "g GCE 2006", $80       ; 'g' is copyright sign
                DW      music1                 ; music from the rom
                DB      $F8, $50, 0,-110     ; height, width, rel y, rel x
                                                ; (from 0,0)
	        DB      "VECTORZOA ANIM TEST",$80  	; some game information,
                                                ; ending with $80
                DB      0                       ; end of game header
;***************************************************************************
; CODE SECTION
;***************************************************************************
                ; labelsLikeThis:
                ; variableslikethis
                ; MyFuctionsLikeThis
; here the cartridge program starts off
; first 2 bytes reserved


main

               	LDA     #1                      
                STA     Vec_Joy_Mux_1_X         
                LDA     #3                      
                STA     Vec_Joy_Mux_1_Y         
                LDA     #0                      
                STA     Vec_Joy_Mux_2_X         
                STA     Vec_Joy_Mux_2_Y         
                                                
		LDD	#$101
		STD	doduffy
		LDD	#0
		STD	posy
		LDA	#$6F
		STA	dscale
		
		CLR	oframe
		CLR	dframe
		LDA	#3
		STA	period
		
		
mainloop	
	        JSR     Wait_Recal         
               	JSR     Intensity_5F
               	JSR     Read_Btns  
               	JSR	Joy_Digital
			
		TST	Vec_Button_1_1
		BEQ	sk_set_duffy
		LDA	doduffy
		EORA	#1
		STA	doduffy
sk_set_duffy
		TST	Vec_Button_1_2
		BEQ	sk_set_mode
		LDA	domode
		EORA	#1
		STA	domode
sk_set_mode
		LDA	Vec_Btn_State
		BITA	#4
		BEQ	sk_upscale
		INC	dscale
sk_upscale		
		BITA	#8
		BEQ	sk_downscale
		DEC	dscale
sk_downscale
		LDA	Vec_Btn_State
		BITA	#12
		BEQ	sk_speed
		TST	Vec_Button_1_2
		BEQ	sk_speed
		LDA	#1
		STA	domode
		DEC	period
		BGT	sk_speed
		
		LDA	#7
		STA	period	
sk_speed

		LDA	period
		LDB	#1
ploop		ASLB
		DECA
		BNE	ploop
		DECB
		STB	pmask
		




		TST	Vec_Joy_1_Y
		BPL	sk_miy
		DEC	posy
		BRA	sk_ply
sk_miy		BEQ	sk_ply
		INC	posy
sk_ply
		TST	Vec_Joy_1_X
		BPL	sk_mix
		DEC	posx
		BRA	sk_plx
sk_mix		BEQ	sk_plx
		INC	posx
sk_plx
	
dloop		
		JSR	Reset0Ref
              	LDA	#$CE
		STA	$D00C
		LDA     #$7F                   
               	STA     VIA_t1_cnt_lo 
		LDD	posy
		JSR	Dot_d
		
		LDA     dscale                   
               	STA     VIA_t1_cnt_lo   
               	       
		LDA	$d009
		STA	time
		TST	doduffy
		BEQ	sk_duffy
			
		LDB	oframe
		ASLB
		LDX	#olist
		LEAX	[B,X]
		TFR	X,Y

		LDB	$C826
		ANDB	pmask
		BNE	sk_reset_oframe	
		INC	oframe
		LDB	oframe
		CMPB	#OUTLINE_FRAMES
		BNE	sk_reset_oframe
		CLR	oframe
sk_reset_oframe		
		
 		;LDX	#draw_outline
 		JSR	Mov_Draw_VLc_a
 		BRA	do_mode
sk_duffy	LDD	1,Y
		JSR	Moveto_d
do_mode	
		TST	domode
		BEQ	sk_mode
		
		LDB	dframe
		ASLB
		LDX	#dlist
		LEAX	[B,X]
		TFR	X,Y

		LDB	$C826
		ANDB	pmask
		BNE	sk_reset_dframe	
		INC	dframe
		LDB	dframe
		CMPB	#DETAIL_FRAMES
		BNE	sk_reset_dframe
		CLR	dframe
sk_reset_dframe	
		
 		;LDX	#draw_detail
 		JSR	Draw_VL_mode
sk_mode		
		
		LDA	time
		SUBA	$D009
		STA	time	
		
		
		JSR	Reset0Ref
              	LDA	#$CE
		STA	$D00C
		LDA     #$7F                   
               	STA     VIA_t1_cnt_lo 
		LDA	#127
		LDB	#-120
		LDU	#vectorzoa_draw
		JSR	Print_Str_d
		
		JSR	Reset0Ref
              	LDA	#$CE
		STA	$D00C
		LDA     #$7F                   
               	STA     VIA_t1_cnt_lo 
		LDA	#-128
		LDB	#-60
		JSR	Moveto_d
		LDA	time
		JSR	Debug_Print_a

		JSR	Reset0Ref
              	LDA	#$CE
		STA	$D00C
		LDA     #$7F                   
               	STA     VIA_t1_cnt_lo 
		LDA	#-128
		LDB	#50
		JSR	Moveto_d
		LDA	dscale
		JSR	Debug_Print_hexa
		
		;JSR	Cycles_Left
		

		BRA	 mainloop		
vectorzoa_draw	DB	"VECTORZOA ANIM TEST",$80
   
		
olist		FDB	draw_outline1,draw_outline2,draw_outline3,draw_outline4
		FDB	draw_outline5,draw_outline6,draw_outline7,draw_outline8			
dlist		FDB	draw_detail1,draw_detail2,draw_detail3,draw_detail4
		FDB	draw_detail5,draw_detail6,draw_detail7,draw_detail8	                  
                
;*************************************************************************** 

Cycles_Left
	JSR 	Reset0Ref
	LDA     #$7F
	STA     VIA_t1_cnt_lo
	LDA	#-100
	CLRB
	JSR	Moveto_d
	CLR	$C823
	CLRA
	LDB	$d009	;T2HOC (upper byte of frame buffer
	JSR	Draw_Line_d
	LDA	$D009
	JSR	Debug_Print_a
	RTS

Debug_Print_a:
		JSR	Calc_Print_a
		LDU	#textpad
		LDD	#0
		JSR	Print_Str
		LDA	#$CE
		STA	$D00C
		
		RTS
		
Calc_Print_a:		

		;LDD	$4040	; H W
		;STD	$C82A
			
		;LDA	#-123

		LDB	#$20
		STB	textpad
		LDB	#$30
		STB	textpad+1
		STB	textpad+2
		STB	textpad+3
		LDB	#$80
		STB	textpad+4


		TSTA
		BPL	skip_negative
		LDB	#$2D
		STB	textpad
		NEGA
				
skip_negative:
		CMPA	#100
		BLT	skip_hundreds
		INC	textpad+1
		SUBA	#100
		
skip_hundreds:
do_tens_loop:	CMPA	#10
		BLT	exit_tens_loop
		INC	textpad+2
		SUBA	#10
		BRA	do_tens_loop
exit_tens_loop:
		
		ADDA	textpad+3
		STA	textpad+3


		RTS


Debug_Print_hexa:
		JSR	Calc_Print_hexa
		LDU	#textpad
		LDD	#0
		JSR	Print_Str
		LDA	#$CE
		STA	$D00C
		RTS
		
		
Calc_Print_hexa:
		;LDD	$4040	; H W
		;STD	$C82A
			
		;LDA	#$A9
		LDB	#$6A
		STB	textpad
		STB	textpad+1
		LDB	#$80
		STB	textpad+2
		
		TFR	A,B
		ANDB	#15
		CMPB	#10
		BLT	number
		ADDB	#$37
		BRA	endn
number:	
		ADDB	#$30
endn:	
		STB	textpad+1

		TFR	A,B
		LSRB
		LSRB
		LSRB
		LSRB
		CMPB	#10
		BLT	number2
		ADDB	#$37
		BRA	endn2
number2:	
		ADDB	#$30
endn2:	
		STB	textpad

		RTS
		


		INCLUDE "EDITTHIS.asm"

	
	
;*************************************************************************** 	
		
		END main